 // 
// Author: Hans Summers, 2015
// Website: http://www.hanssummers.com
//
// A very very simple Si5351a demonstration
// using the Si5351a module kit http://www.hanssummers.com/synth
// Please also refer to SiLabs AN619 which describes all the registers to use
//
#include <inttypes.h>
#include "i2c.h"
#include "i2c.c"
#include "si5351a.h"

#include "SPI.h"
#include "TFT_ILI9341.h"

#define TFT_GREY 0x7BEF

TFT_ILI9341 myGLCD = TFT_ILI9341(); 

// Variablen für Messung
double Fstart_MHz = 1;      // Start Frequency for sweep
//double Fstop_MHz = 10;    // Stop Frequency for sweep
double Fstop_MHz = 30;      // Stop Frequency for sweep
double current_freq_MHz;    // Temp variable used during sweep
long serial_input_number;   // Used to build number from serial stream
int num_steps = 100;        // Number of steps to use in the sweep
char incoming_char;         // Character read from serial stream
double freq;                // Frequenz
bool pc_flag;               // Use PC values and not Analog Value

// Variablen für Display
double vswrArray[120];       // Array für SWR
int z = 0;                   // Index für Array
double SwrFreq = 14;         // Variable für Freq. mit SWR Min.
double SwrMin = 100;         // Variable für SWR Min.
double Freq1 = 1;            // Freq. Links unterste Zeile Display
double Freq2 = 15;           // Freq. Mitte unterste Zeile Display
double Freq3 = 30;           // Freq. Mitte unterste Zeile Display
unsigned long milliold = 0;  // Millisekunden für Entprellung Interrupt
bool flag = 0;               // wir auf 1 gesetzt bei Interrupt, in void Loop perform_sweep
double counter = 0;          // Zähler um erste Interrupts zu ignorieren
bool flag_graph = 1;         // Merker - Wurde Graph gezeichnet ?
bool deleteflag = 0;         // Merker Display Clear




void setup() {  
  //Used for Reset TFT
  pinMode(12, OUTPUT);
  digitalWrite(12, HIGH);
  delay(500);
  digitalWrite(12, LOW);
  delay(500);
  digitalWrite(12, HIGH);
  delay(500);

  //TFT D/C = A3 in Setup.h
  
 // Setup the LCD
  myGLCD.init();
  myGLCD.setRotation(1); 
  myGLCD.fillScreen(TFT_BLACK);
  myGLCD.setTextColor(TFT_GREEN, TFT_BLACK);
  myGLCD.setCursor(0, 80);
  myGLCD.setTextSize(3);
  myGLCD.println("DG7EAO");
  myGLCD.println("   Antennen");
  myGLCD.println("      Analysator");
  delay(3000);
  counter = counter + 1;
  
  myGLCD.fillRect(0, 50, 300, 300,TFT_BLACK); 

  i2cInit();
  si5351aSetFrequency(10000000);

  // Set up analog inputs on A0 and A1, internal reference voltage
  pinMode(A0,INPUT);
  pinMode(A1,INPUT);
  pinMode(A2,INPUT);
  analogReference(INTERNAL);
  
  // initialize serial communication at 57600 baud
  Serial.begin(57600);
  
  //Initialise the incoming serial number to zero
  serial_input_number=0; 

  //Tasten Interrupt an PIN 2
  pinMode(2,OUTPUT);
  digitalWrite(2, HIGH);
  attachInterrupt(0, key2, FALLING);
  unsigned long milliold = millis();       
}






void loop() {
  
  // Setze Frequenz
  si5351aSetFrequency(14060000);


String str;
if(Serial.available() > 0)
    {str = Serial.readStringUntil('\n'); }


// bei pc_flag = true; nehme PC-Werte und nicht Analog-Einstellung    

// 10000000A
if (str.endsWith("A")){ 
  Fstart_MHz = str.substring(0, str.length() -1).toFloat()/1000000;
      pc_flag = true;}

// 20000000B
if (str.endsWith("B")){
  Fstop_MHz = str.substring(0, str.length() -1).toFloat()/1000000;
      pc_flag = true;}

// C
if (str == "C"){
      //Turn frequency into FStart and set DDS output to single frequency
      Fstart_MHz = str.substring(1).toFloat()/1000000;
      //SetDDSFreq(Fstart_MHz);
      si5351aSetFrequency(Fstart_MHz * 1000000);}

 // 102N
 if (str.endsWith("N")){
      // Set number of steps in the sweep
      num_steps = str.substring(0, str.length() -1).toFloat();
      pc_flag = true;
      }       

// s
if (str == "s" | str == "S"){ Perform_sweep();}


// ?
if (str == "?"){
      // Report current configuration to PC    
      Serial.print("Start Freq:");
      Serial.println(Fstart_MHz*1000000);
      Serial.print("Stop Freq:");
      Serial.println(Fstop_MHz*1000000);
      Serial.print("Num Steps:");
      Serial.println(num_steps); 
}
    Serial.flush(); 

  // Perform Sweep nach Interrupt PIN2
  // ingnoriere Startup Interrupts durch counter
 
 if (flag == 1 && counter >1)  
{
  Perform_sweep();  
  flag_graph = 1; 
} 

else
{  
 flag_graph = 0;

 if (deleteflag == 0){
 myGLCD.fillScreen(TFT_BLACK); 
 }
 
}



delay(100);




  // Read Sollwert von Poti an A2
  int soll = analogRead(A2);
  int x;
  x = (soll / 30)+3;
  if (x > 30) x = 31;
  if (soll > 1000) x = 50;
  if (soll > 1010) x = 144;  
    

 
 
 // bei pc_flag = true; nehme PC-Werte und nicht Analog-Einstellung   
 
 
 // Setze Frequenzbereich
 if (pc_flag == false)
 {
 Fstart_MHz = x-2;  // Start Frequency for sweep
 Fstop_MHz = x+2;   // Stop Frequency for sweep 
 num_steps = 102;   // Steps
 }
 
 Freq1 = x-2;      // Unterste Zeile Display Freq. Links
 Freq2 = x;        // Unterste Zeile Display Freq. Mitte
 Freq3 = x+2;      // Unterste Zeile Display Freq. Rechts

 
 
 if (pc_flag == true)
 {
 Freq1 = Fstart_MHz;      // Unterste Zeile Display Freq. Links
 Freq2 = Fstart_MHz + (Fstop_MHz - Fstart_MHz)/2; // Unterste Zeile Display Freq. Mitte
 Freq3 = Fstop_MHz;     // Unterste Zeile Display Freq. Rechts
 }

 // Special with x = 0 do big scan
 if (x==31 && pc_flag == false)
 {
 Fstart_MHz = 1;  // Start Frequency for sweep
 Fstop_MHz = 30;   // Stop Frequency for sweep

 Freq1 = 1;      // Unterste Zeile Display Freq. Links
 Freq2 = 15;     // Unterste Zeile Display Freq. Mitte
 Freq3 = 30;     // Unterste Zeile Display Freq. Rechts 
 }
  
 
  if (flag_graph == 0 || counter == 1)
  {   

    myGLCD.setTextSize(3);
    myGLCD.setCursor(40, 10);
    myGLCD.println("Set Frequenz"); 
    myGLCD.setCursor(100, 60);
    myGLCD.print(String(x) + " MHz  ");
    deleteflag = 1;   
  }
  
}
 


void Perform_sweep(){
  double FWD=0;
  double REV=0;
  double VSWR;
  double Fstep_MHz = (Fstop_MHz-Fstart_MHz)/num_steps;
  
  z = 0;
  SwrMin = 100;  
   
  // Start loop 
  for(int i=0;i<=num_steps;i++){
    // Calculate current frequency
    current_freq_MHz = Fstart_MHz + i*Fstep_MHz;
    // Set DDS to current frequency
    si5351aSetFrequency(current_freq_MHz*1000000); 
    // Wait a little for settling
    delay(20);
    // Read the forward and reverse voltages
    
    REV = analogRead(A0);
    FWD = analogRead(A1);
    
    
    if (REV >= FWD) REV = FWD-1;
     
    VSWR = (FWD+REV)/(FWD-REV);
          
    //Skalieren für Ausgabe
    VSWR = VSWR * 1000;
    
    // Kalibrierung
    // Widerstände > 50 Ohm = Load / 50 = SWR
    // Widerstände < 50 Ohm = 50 Ohm / Load = SWR
    
    // 100 Ohm >> SWR 2
    // 150 Ohm >> SWR 3
    // 470 Ohm >> SWR 9,4
    //  10 Ohm >> SWR 5      
    

    if (Fstop_MHz > 30) {goto weiter;}
    
    //if ((VSWR > 4000) && (VSWR < 14999)) {VSWR = VSWR*1.18;}         
    //if ((VSWR > 2999) && (VSWR < 4000)) {VSWR = VSWR*1.17;} 
    //if ((VSWR > 1999) && (VSWR < 3000)) {VSWR = VSWR*1.16;} 
    //if ((VSWR > 1299) && (VSWR < 2000)) {VSWR = VSWR*1.14;} 
    //if ((VSWR > 1100) && (VSWR < 1300)) {VSWR = VSWR*1.12;} 
   
    VSWR = VSWR - 800;
    if (VSWR < 1000) VSWR = 1001;
    

    // No Correction for high frequency
    weiter:
    
    // Send current line back to PC over serial bus
    Serial.print(current_freq_MHz*1000000);
    Serial.print(",0,");
    Serial.print(VSWR);
    Serial.print(",");
    Serial.print(FWD);
    Serial.print(",");
    Serial.println(REV);

   
  
    // Übergebe SWR an Array
    // Ermittele Freq bei niedrigsten SWR
    vswrArray[z] = VSWR/1000;
        
    if (vswrArray[z] > 10) vswrArray[z] = 10;
    
    if (vswrArray[z] < SwrMin && vswrArray[z] > 1) 
    {
    SwrMin = vswrArray[z];
    SwrFreq = current_freq_MHz;    
    }    
    
    z = z + 1;
  
  }
  // Send "End" to PC to indicate end of sweep
  Serial.println("End");
  Serial.flush(); 

     //graphic();
     CreateGrid();

     //double last = 10;
     double last = vswrArray[0];
     double xx = 6;
     int j = 1;

    for (int i = 1 ;i < 103; i++){
      xx = vswrArray[i];
      
  myGLCD.drawLine(j,210-last*18, j+1, 210-xx*18,TFT_RED);
  myGLCD.drawLine(j+1,210-last*18, j+2, 210-xx*18,TFT_RED);
 
      j = j + 3;
      last = xx;  
      }
}









// Interrupt Service Routine
// Abfrage Low an Pin 2
void key2()
{
  
  if ((millis() - milliold) < 1000) return;
  
  counter = counter + 1;   

  flag = !flag; 

  deleteflag= 0;

milliold = millis();
  
}








void CreateGrid()
{
  
  myGLCD.setTextSize(2);
  myGLCD.fillScreen(TFT_BLACK);
  myGLCD.setTextColor(TFT_GREEN, TFT_BLACK);

  myGLCD.setCursor(0, 0);

  myGLCD.print("SWR ");
  myGLCD.print(SwrMin);
  myGLCD.print("  Freq ");
  myGLCD.print(SwrFreq,3);
  
    double maxSwr = 10;

        // Horizontale Linien
        myGLCD.drawLine(0, 30, 310, 30,TFT_WHITE);
        myGLCD.drawLine(0, 120, 310, 120,TFT_WHITE);
        myGLCD.drawLine(0, 196, 310, 196,TFT_WHITE);
        myGLCD.drawLine(0, 210, 310, 210,TFT_WHITE);

        // Vertikale Linien
        myGLCD.drawLine(0, 30, 0, 210,TFT_WHITE);
        myGLCD.drawLine(78, 30, 78, 210,TFT_WHITE);
        myGLCD.drawLine(155, 30, 155, 210,TFT_WHITE);
        myGLCD.drawLine(233, 30, 233, 210,TFT_WHITE);
        myGLCD.drawLine(310, 30, 310, 210,TFT_WHITE);

        // 3 Frequenz Beschriftungen
        myGLCD.setCursor(0, 215);
        myGLCD.print(Freq1,0);
        myGLCD.setCursor(140, 215);
        myGLCD.print(Freq2,0);
        myGLCD.setCursor(280, 215);
        myGLCD.print(Freq3,0);

        myGLCD.setTextSize(1);
        myGLCD.setCursor(5, 35);
        myGLCD.print("10");
        myGLCD.setCursor(5, 125);
        myGLCD.print("5");
}



// Set up specified PLL with mult, num and denom
// mult is 15..90
// num is 0..1,048,575 (0xFFFFF)
// denom is 0..1,048,575 (0xFFFFF)
//
void setupPLL(uint8_t pll, uint8_t mult, uint32_t num, uint32_t denom)
{
  uint32_t P1;          // PLL config register P1
  uint32_t P2;          // PLL config register P2
  uint32_t P3;          // PLL config register P3

  P1 = (uint32_t)(128 * ((float)num / (float)denom));
  P1 = (uint32_t)(128 * (uint32_t)(mult) + P1 - 512);
  P2 = (uint32_t)(128 * ((float)num / (float)denom));
  P2 = (uint32_t)(128 * num - denom * P2);
  P3 = denom;

  i2cSendRegister(pll + 0, (P3 & 0x0000FF00) >> 8);
  i2cSendRegister(pll + 1, (P3 & 0x000000FF));
  i2cSendRegister(pll + 2, (P1 & 0x00030000) >> 16);
  i2cSendRegister(pll + 3, (P1 & 0x0000FF00) >> 8);
  i2cSendRegister(pll + 4, (P1 & 0x000000FF));
  i2cSendRegister(pll + 5, ((P3 & 0x000F0000) >> 12) | ((P2 & 0x000F0000) >> 16));
  i2cSendRegister(pll + 6, (P2 & 0x0000FF00) >> 8);
  i2cSendRegister(pll + 7, (P2 & 0x000000FF));
}

//
// Set up MultiSynth with integer divider and R divider
// R divider is the bit value which is OR'ed onto the appropriate register, it is a #define in si5351a.h
//
void setupMultisynth(uint8_t synth, uint32_t divider, uint8_t rDiv)
{
  uint32_t P1;          // Synth config register P1
  uint32_t P2;          // Synth config register P2
  uint32_t P3;          // Synth config register P3

  P1 = 128 * divider - 512;
  P2 = 0;             // P2 = 0, P3 = 1 forces an integer value for the divider
  P3 = 1;

  i2cSendRegister(synth + 0,   (P3 & 0x0000FF00) >> 8);
  i2cSendRegister(synth + 1,   (P3 & 0x000000FF));
  i2cSendRegister(synth + 2,   ((P1 & 0x00030000) >> 16) | rDiv);
  i2cSendRegister(synth + 3,   (P1 & 0x0000FF00) >> 8);
  i2cSendRegister(synth + 4,   (P1 & 0x000000FF));
  i2cSendRegister(synth + 5,   ((P3 & 0x000F0000) >> 12) | ((P2 & 0x000F0000) >> 16));
  i2cSendRegister(synth + 6,   (P2 & 0x0000FF00) >> 8);
  i2cSendRegister(synth + 7,   (P2 & 0x000000FF));
}

//
// Switches off Si5351a output
// Example: si5351aOutputOff(SI_CLK0_CONTROL);
// will switch off output CLK0
//
void si5351aOutputOff(uint8_t clk)
{
  i2cSendRegister(clk, 0x80);   // Refer to SiLabs AN619 to see bit values - 0x80 turns off the output stage
}

// 
// Set CLK0 output ON and to the specified frequency
// Frequency is in the range 1MHz to 150MHz
// Example: si5351aSetFrequency(10000000);
// will set output CLK0 to 10MHz
//
// This example sets up PLL A
// and MultiSynth 0
// and produces the output on CLK0
//
void si5351aSetFrequency(uint32_t frequency)
{
  uint32_t pllFreq;
  uint32_t xtalFreq = XTAL_FREQ;
  uint32_t l;
  float f;
  uint8_t mult;
  uint32_t num;
  uint32_t denom;
  uint32_t divider;

  divider = 900000000 / frequency;// Calculate the division ratio. 900,000,000 is the maximum internal 
                  // PLL frequency: 900MHz
  if (divider % 2) divider--;   // Ensure an even integer division ratio

  pllFreq = divider * frequency;  // Calculate the pllFrequency: the divider * desired output frequency

  mult = pllFreq / xtalFreq;    // Determine the multiplier to get to the required pllFrequency
  l = pllFreq % xtalFreq;     // It has three parts:
  f = l;              // mult is an integer that must be in the range 15..90
  f *= 1048575;         // num and denom are the fractional parts, the numerator and denominator
  f /= xtalFreq;          // each is 20 bits (range 0..1048575)
  num = f;            // the actual multiplier is  mult + num / denom
  denom = 1048575;        // For simplicity we set the denominator to the maximum 1048575

                  // Set up PLL A with the calculated multiplication ratio
  setupPLL(SI_SYNTH_PLL_A, mult, num, denom);
                  // Set up MultiSynth divider 0, with the calculated divider. 
                  // The final R division stage can divide by a power of two, from 1..128. 
                  // reprented by constants SI_R_DIV1 to SI_R_DIV128 (see si5351a.h header file)
                  // If you want to output frequencies below 1MHz, you have to use the 
                  // final R division stage
  setupMultisynth(SI_SYNTH_MS_0, divider, SI_R_DIV_1);
                  // Reset the PLL. This causes a glitch in the output. For small changes to 
                  // the parameters, you don't need to reset the PLL, and there is no glitch
  i2cSendRegister(SI_PLL_RESET, 0xA0);  
                  // Finally switch on the CLK0 output (0x4F)
                  // and set the MultiSynth0 input to be PLL A
  i2cSendRegister(SI_CLK0_CONTROL, 0x4F | SI_CLK_SRC_PLL_A);
}


  
